#!/usr/bin/env python

import sys
from PyQt4 import QtGui, QtCore


class Widget(QtGui.QDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        layout = QtGui.QVBoxLayout(self)
        button = QtGui.QPushButton('Copy')
        layout.addWidget(button)
        self.connect(button, QtCore.SIGNAL('clicked()'), self.copy)
        button = QtGui.QPushButton('Paste')
        layout.addWidget(button)
        self.connect(button, QtCore.SIGNAL('clicked()'), self.paste)

    def copy(self):
        clip = QtGui.QApplication.clipboard()

        # # This works OK:
        # clip.setText('Test Text')

        # This seg-faults on paste:
        mime = QtCore.QMimeData()
        mime.setData('text/plain', 'Test Text')
        clip.setMimeData(mime)

        # # This works, but sometimes seg-faults at exit:
        # self.mime = QtCore.QMimeData()
        # self.mime.setData('text/plain', 'Test Text')
        # clip.setMimeData(self.mime)


    def paste(self):
        clip = QtGui.QApplication.clipboard()
        mimeData = clip.mimeData()
        text = unicode(QtCore.QString(mimeData.data('text/plain'))) 
        # text = str(clip.text())
        print 'Pasted: ', text


if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    win = Widget()
    win.show()
    app.exec_()

